<script setup lang="ts">
import { useReceiptStore } from '@/stores/receipt';
import { useAuthStore } from '@/stores/auth';
import { usePromotionStore } from '@/stores/promotion';
import { useMemberStore } from '@/stores/member';
import type { ReceiptItem } from '@/types/ReceiptItem';
const receiptStore = useReceiptStore()
const authStore = useAuthStore()
const promotionStore = usePromotionStore()
const memberStore = useMemberStore()
function size(item: ReceiptItem): string {
    if(item.product!=undefined){
        if (item.product?.gsize != '-') {
            return '(' + item.product.gsize + ')'
        }
        
    }
    return ''
  
}

function type(item: ReceiptItem): string {
    if(item.product!=undefined){
  if (item.product?.type !='-') {
    return '(' + item.product.type + ')'
  }
  
}return ''
}

function sweetLv(item: ReceiptItem): string {
    if(item.product!=undefined){
  if (item.product?.sweet_level!='-') {
    return '(' + item.product.sweet_level + ')' 
  }
  
}return ''
}
function closeDialog(){
    receiptStore.closeDialog()
    receiptStore.deletePoint()
    receiptStore.calReceipt()
}

function comfirmDialog(){
    receiptStore.receiptDialog =false
    receiptStore.addReceipt()
    receiptStore.clear()
}
</script>
<template>
    <v-dialog v-model="receiptStore.receiptDialog" persistent width="auto" height="auto" scrollable>
        <v-card>
            <v-card-title>Receipt</v-card-title>
            <v-card-text justify="center" align="center" style="border: 1px solid;">
                <v-img
                    :width="100"
                    aspect-ratio="1/1"
                    src="./img/logo/logo.png"
                ></v-img>
                <!-- head -->
                <v-container>
                    <v-row justify="center">D-Coffee</v-row>
                    <v-row justify="center" style="font-size: 10px;">สาขา อาคารวิทยาศาสตร์การแพทย์ คณะสหเวชศาสตร์</v-row>
                    <v-row justify="center" style="font-size: 10px;">ม.บูรพา โทร 095-3325290</v-row>
                    <br><br>
                    <v-row justify="center" style="font-size: 10px;">ใบเสร็จรับเงิน/ใบกำกับภาษีอย่างย่อ</v-row>
                </v-container>
                <v-divider></v-divider>
                <!-- เวลา และ user -->
                <v-container class="pa-0">
                    <v-row no-gutters class="justify-start" >
                        <v-col>
                            <div>
                                <p style="font-size: 10px;text-align: left;">Date: {{ receiptStore.textDate[0] }}</p>
                                <p style="font-size: 10px;text-align: left;">Time: {{ receiptStore.textDate[1] }}</p>
                            </div>
                        </v-col>
                        <v-col><p style="font-size: 10px;text-align: right;">User: {{ authStore.currentUser?.fullname }}</p></v-col>
                    </v-row>
                </v-container>
                <v-divider></v-divider>
                <!-- ตาราง -->
                <v-container class="pa-0">
                    <v-table density="compact">
                        <thead>
                            <tr style="font-size: 10px;text-align: left;">
                                <th>Name</th>
                                <th>Unit</th>
                                <th>Price</th>
                                <th>Total</th>
                            </tr>
                        </thead>
                        <tbody>
                            <tr v-for="(item) of receiptStore.receipt.receiptItems" :key="item.id" style="font-size: 10px;text-align: left;">
                                <td>{{ item.name + type(item) + size(item) + sweetLv(item) }}</td>
                                <td>{{ item.unit }}</td>
                                <td>{{ item.price }} ฿</td>
                                <td>{{ item.unit*item.price }} ฿</td>
                            </tr>
                        </tbody>
                    </v-table>
                </v-container>
                <v-divider></v-divider>
                <!-- รายละเอียด -->
                <v-container  class="pa-0" style="width: 300px;" >
                    <v-row no-gutters>
                        <v-divider></v-divider>
                        <v-col cols="6" style="font-size:11px;text-align: left;"><p>สมาชิก: {{ receiptStore.receipt.member ? receiptStore.receipt.member.name : '-' }}</p></v-col> 
                        <v-col cols="6" style="font-size:11px;text-align: left;"><p>แต้ม: {{ receiptStore.receipt.member ? receiptStore.receipt.member.point : '-' }}</p></v-col>
                        <v-divider></v-divider>
                        <v-col cols="12" style="font-size:11px;text-align: left;"><p>โปรโมชั่น: {{ receiptStore.receipt.promotion ? receiptStore.receipt.promotion.name : '-' }}</p></v-col> 
                        <v-col cols="12" style="font-size:11px;text-align: left;"><p>ส่วนลดโปรโมชั่น: {{ receiptStore.receipt.promotion ? receiptStore.receipt.promotionDiscount+' ฿': '-' }} </p></v-col>
                        <v-divider></v-divider>
                        <v-col cols="6" style="font-size:11px;text-align: left;"><p>ราคา: {{ receiptStore.receipt.totalBefore }} ฿</p></v-col>
                        <v-col cols="6" style="font-size:11px;text-align: left;"><p>ส่วนลด: {{ receiptStore.receipt.memberDiscount+receiptStore.receipt.promotionDiscount }} ฿</p></v-col>
                        <v-col cols="6" style="font-size:11px;text-align: left;"><p>ราคารวมทั้งสิ้น: {{ receiptStore.receipt.total }} ฿</p></v-col>
                        <v-col cols="6" style="font-size:11px;text-align: left;"><p>วิธีการจ่าย: {{ receiptStore.receipt.paymentType }}</p></v-col>
                        <v-col cols="6" style="font-size:11px;text-align: left;"><p>เงิน: {{ receiptStore.receipt.receivedAmount }} ฿</p></v-col>
                        <v-col cols="6" style="font-size:11px;text-align: left;"><p>เงินทอน: {{ receiptStore.receipt.change }} ฿</p></v-col>
                        
                    </v-row>
                </v-container>
                <v-divider></v-divider>
                <p style="font-size: 11px;padding-top: 10px;">ขอบคุณที่ใช้บริการค่ะ</p>
            </v-card-text>
            <v-card-actions>
                <v-spacer>
                </v-spacer>
                <v-btn @click="receiptStore.changeComponent(1),closeDialog()">ยกเลิก</v-btn>
                <v-btn v-if="receiptStore.receipt.id ==-1" @click="comfirmDialog()">ยืนยัน</v-btn>
            </v-card-actions>
        </v-card>
    </v-dialog>
</template>
<style scoped>
tbody tr:nth-of-type(even) {
  background-color: white;
}

tbody tr:nth-of-type(odd) {
  background-color: white;
}

thead {
  background-color: white;
  color: rgb(0, 0, 0);
  font-weight: bold;
}
.theme--light.v-data-table thead tr th {
  color: white;
}
</style>